/*
 * This file is autogenerated, see util/job-gen.py and dat/jobs/ for more info.
 */
#pragma once

#include "macros.h"
#include "tag-version.h"

enum job_type
{
/*
 * Enums are currently hardcoded, for save compatibility. species_gen.py can
 * create these values itself, by setting `create_enum` true for a particular
 * species, but this is not recommended: species enum order when generated
 * this way may change as new species are added, breaking old saves.
 */
    JOB_FIGHTER,
    JOB_HEDGE_WIZARD,
#if TAG_MAJOR_VERSION == 34
    JOB_PRIEST,
#endif
    JOB_GLADIATOR,
    JOB_NECROMANCER,
    JOB_BRIGAND,
    JOB_BERSERKER,
    JOB_HUNTER,
    JOB_CONJURER,
    JOB_ENCHANTER,
    JOB_FIRE_ELEMENTALIST,
    JOB_ICE_ELEMENTALIST,
    JOB_SUMMONER,
    JOB_AIR_ELEMENTALIST,
    JOB_EARTH_ELEMENTALIST,
#if TAG_MAJOR_VERSION == 34
    JOB_SKALD,
#endif
    JOB_ALCHEMIST,
    JOB_CHAOS_KNIGHT,
    JOB_SHAPESHIFTER,
#if TAG_MAJOR_VERSION == 34
    JOB_HEALER,
    JOB_STALKER,
#endif
    JOB_MONK,
    JOB_WARPER,
    JOB_WANDERER,
    JOB_ARTIFICER,                     //   Greenberg/Bane
    JOB_HEXSLINGER,
#if TAG_MAJOR_VERSION == 34
    JOB_DEATH_KNIGHT,
    JOB_ABYSSAL_KNIGHT,
    JOB_JESTER,
#endif
    JOB_DELVER,
    JOB_CINDER_ACOLYTE,
    JOB_REAVER,

    // Auto-generated enums start here
    NUM_JOBS,

    JOB_UNKNOWN = 100,
    JOB_RANDOM,
    JOB_VIABLE,
};
COMPILE_CHECK(NUM_JOBS < JOB_UNKNOWN);
